#<hr>
#Datei: <b>panel-Demo</b><p>
#Author: <b>Michael Eisele</b><p>
#Datum: <b>19.07.2001</b><p>
#<hr>

variables {
  CanMessage_Ramp    msg_ramp;
  CanMessage_Signals msg_signals;
  timer txTimer;
  int   value_ramp;
  int   value_dreieck;
  int   dir_dreieck;
  int   sends; // Ramp
  int   sendr; // Sin
  int   send_brs;
  int   send_fdf;
  int   counter;
  int   counter_rx;
  int   counter_rx_prev;
  int   echo_seen;
  int   errors;
  double   time;
  double   amplitude;

  const ECHO_SEEN_RELOAD = 1000;
  const CAN1 = 0;
  const CAN2 = 1;
  const CAN3 = 2;
  const CAN4 = 3;
}


double add (double a, int b)
{
  return a + b;
} // add


on start {
  printf ("*** GENSIG/FD started ***\n");
  dir_dreieck = 1;
  value_ramp = 0;
  value_dreieck = 0;
  time = 0;
  errors = 0;
  amplitude = 500;
  txTimer.timeout = 1;
  timerStart (txTimer);
  sends = 1;
  sendr = 1;
  send_brs = 1;
  send_fdf = 1;
  counter = 0;
  echo_seen = 0;
  ioSetOutput (IO_LED1, 0);
}


on action "halt" {
  printf ("halt\n");
  timerCancel (txTimer);
}


on action "run" {
  printf ("run\n");
  timerStart (txTimer);
}


on signal "amp" {
  printf ("amp=%f\n", this);
  amplitude = this;
}


on signal "time" {
  printf ("time=%f\n", this);
}


on key 'c' {
  printf ("Reset CAN channels\n");

  canChannelBusOff (CAN3);
  canChannelBusOff (CAN4);
  canChannelBusOn (CAN3);
  canChannelBusOn (CAN4);
}


//on key 'f' {
//  printf ("CAN BUSOFF\n");
//
//  canChannelBusOff (CAN3);
//  canChannelBusOff (CAN4);
//}
//
//on key 'o' {
//  printf ("CAN BUSON\n");
//
//  canChannelBusOn (CAN3);
//  canChannelBusOn (CAN4);
//}


on key 'a' {
  printf ("Increase amplitude, %f\n", amplitude);
  amplitude += 50;
  if (amplitude > 1000) amplitude = 1000;
}

on key 's' {
  printf ("Decrease amplitude, %f\n", amplitude);
  amplitude -= 50;
  if (amplitude < 0) amplitude = 0;
}


on key 'x' {
  sendr = !sendr;
  printf ("sendr=%d\n", sendr);

}


on key 'y' {
  sends = !sends;
  printf ("sends=%d\n", sends);
}


on key 'b' {
  send_brs = !send_brs;
  printf ("send_brs=%d\n", send_brs);
}


on key 'f' {
  send_fdf = !send_fdf;
  printf ("send_fdf=%d\n", send_fdf);
}


on stopped {
  printf ("*** Stopped ***\n");
}


on CanMessage 50 { // echo message

  counter_rx = this.data [2] & 0xff;
  counter_rx <<= 8;
  counter_rx += this.data [3] & 0xff;

  counter_rx_prev += 1;
  counter_rx_prev &= 0xffff;

  //printf ("id=%d", this.id);
  //if (this.flags & CANMSG_FLAG_BRS) printf (" BRS");
  //if (this.flags & CANMSG_FLAG_FDF) printf (" FDF");
  //printf ("\n");

  if (counter_rx == counter_rx_prev) {
    if (echo_seen == 0) {
      ioSetOutput (IO_LED1, 1);
      printf ("ECHO SEEN!!!\n");
      errors = 0;
    }
    echo_seen = ECHO_SEEN_RELOAD;
  }
  else {
    if (errors < 100) {
      printf ("Echo: ch=%d counter=%d/%d flags=%08x errs=%d @%d (%02x %02x %02x %02x . %02x %02x %02x %02x)\n",
              this.channel,
              counter_rx,
              counter_rx_prev,
              this.flags,
              errors,
              this.timestamp,
              this.data [0],
              this.data [1],
              this.data [2],
              this.data [3],

              this.data [4],
              this.data [5],
              this.data [6],
              this.data [7] );

      errors += 1;
    }
  }

  counter_rx_prev = counter_rx;
}


on timer txTimer {
  timerStart (txTimer);

  if (echo_seen > 0) {
    echo_seen -= 1;
    if (echo_seen == 0) {
      ioSetOutput (IO_LED1, 0);
      printf ("ECHO MISSING!!!\n");
    }
  }

  // prepare message, RAMP
  msg_ramp.flags = 0;
  msg_ramp.dlc = 8;
  msg_ramp.Rampe.Phys   = value_ramp++ % 1000;
  msg_ramp.Dreieck.Phys = value_dreieck;

  msg_ramp.data [ 4] = counter >> 8;
  msg_ramp.data [ 5] = counter;
  msg_ramp.data [ 6] = 0x00;
  msg_ramp.data [ 7] = 0x11;
  msg_ramp.data [ 8] = 0x22;
  msg_ramp.data [ 9] = 0x33;
  msg_ramp.data [10] = 0x44;
  msg_ramp.data [11] = 0x55;

  value_dreieck = value_dreieck + dir_dreieck;
  if (value_dreieck >=  1000) dir_dreieck = -1;
  if (value_dreieck <= -1000) dir_dreieck =  1;


  // prepare message, SIGNALS
  msg_signals.flags = 0;
  msg_signals.dlc = 8;
  msg_signals.Sinus.Phys   = amplitude * sin (time * M_PI / 1000);
  msg_signals.Cosinus.Phys = amplitude * cos (time * M_PI / 1000);

  msg_signals.SinState.Phys = 0;
  if (msg_signals.Sinus.Phys < 0) msg_signals.SinState.Phys = 1;
  else if (msg_signals.Sinus.Phys > 0) msg_signals.SinState.Phys = 2;

  msg_signals.data [ 4] = counter >> 8;
  msg_signals.data [ 5] = counter;
  msg_signals.data [ 6] = 0x01;
  msg_signals.data [ 7] = 0x02;
  msg_signals.data [ 8] = 0x03;
  msg_signals.data [ 9] = 0x04;
  msg_signals.data [10] = 0x05;
  msg_signals.data [11] = 0x06;

  // Send messages
  if (sendr) {
    msg_ramp.data [ 7] = CAN1;
    canChannelSendMessage (CAN1, msg_ramp); // standard CAN

    msg_ramp.data [ 7] = CAN2;
    canChannelSendMessage (CAN2, msg_ramp); // standard CAN
    //canSendMessage (msg_ramp);

    if (send_fdf) { // extend to CAN FD messages
      if (send_brs) msg_ramp.flags += CANMSG_FLAG_BRS;
      msg_ramp.flags += CANMSG_FLAG_FDF;
      msg_ramp.dlc = 12;
    }

    msg_ramp.data [ 7] = CAN3;
    canChannelSendMessage (CAN3, msg_ramp); // CAN FD

    msg_ramp.data [ 7] = CAN4;
    canChannelSendMessage (CAN4, msg_ramp); // CAN FD
  }

  if (sends) {
    msg_signals.data [ 7] = CAN1;
    canChannelSendMessage (CAN1, msg_signals); // standard CAN

    msg_signals.data [ 7] = CAN2;
    canChannelSendMessage (CAN2, msg_signals); // standard CAN

    if (send_fdf) { // extend to CAN FD messages
      if (send_brs) msg_signals.flags += CANMSG_FLAG_BRS;
      msg_signals.flags += CANMSG_FLAG_FDF;
      msg_signals.dlc = 12;
    }

    msg_signals.data [ 7] = CAN3;
    canChannelSendMessage (CAN3, msg_signals); // CAN FD

    msg_signals.data [ 7] = CAN4;
    canChannelSendMessage (CAN4, msg_signals); // CAN FD
  }

  time += 1;
  counter += 1;
}


